{
    "$graph": [
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/input_coords"
                },
                {
                    "type": "File",
                    "id": "#main/input_mirna"
                },
                {
                    "type": "File",
                    "id": "#main/input_model_with_bls"
                },
                {
                    "type": "File",
                    "id": "#main/input_model_without_bls"
                },
                {
                    "type": "File",
                    "id": "#main/input_mrna"
                },
                {
                    "type": "File",
                    "id": "#main/input_multiple_alignments"
                },
                {
                    "type": "File",
                    "id": "#main/input_tree"
                },
                {
                    "type": "string",
                    "id": "#main/output_file_name"
                },
                {
                    "type": "int",
                    "id": "#main/settings_contextLen_L"
                },
                {
                    "type": "int",
                    "id": "#main/settings_contextLen_U"
                },
                {
                    "type": "int",
                    "id": "#main/settings_index_after_split"
                },
                {
                    "type": "float",
                    "id": "#main/settings_mirza_threshold"
                },
                {
                    "type": "string",
                    "id": "#main/settings_split_by"
                }
            ],
            "steps": [
                {
                    "run": "#calculate_contrafold.cwl",
                    "scatter": "#main/calculate_contrafold/coords",
                    "in": [
                        {
                            "source": "#main/settings_contextLen_L",
                            "id": "#main/calculate_contrafold/contextLen_L"
                        },
                        {
                            "source": "#main/input_coords",
                            "id": "#main/calculate_contrafold/coords"
                        },
                        {
                            "source": "#main/input_mrna",
                            "id": "#main/calculate_contrafold/seq"
                        }
                    ],
                    "out": [
                        "#main/calculate_contrafold/output"
                    ],
                    "id": "#main/calculate_contrafold"
                },
                {
                    "run": "#calculate_distance.cwl",
                    "scatter": "#main/calculate_distance/coords",
                    "in": [
                        {
                            "source": "#main/input_coords",
                            "id": "#main/calculate_distance/coords"
                        },
                        {
                            "source": "#main/input_mrna",
                            "id": "#main/calculate_distance/seq"
                        }
                    ],
                    "out": [
                        "#main/calculate_distance/output"
                    ],
                    "id": "#main/calculate_distance"
                },
                {
                    "run": "#calculate_flanks_composition.cwl",
                    "scatter": "#main/calculate_flanks/coords",
                    "in": [
                        {
                            "source": "#main/input_coords",
                            "id": "#main/calculate_flanks/coords"
                        },
                        {
                            "source": "#main/input_mrna",
                            "id": "#main/calculate_flanks/seq"
                        }
                    ],
                    "out": [
                        "#main/calculate_flanks/output"
                    ],
                    "id": "#main/calculate_flanks"
                },
                {
                    "run": "#calculate_MIRZA.cwl",
                    "scatter": "#main/calculate_mirza/coords",
                    "in": [
                        {
                            "source": "#main/input_coords",
                            "id": "#main/calculate_mirza/coords"
                        },
                        {
                            "source": "#main/input_mirna",
                            "id": "#main/calculate_mirza/motifs"
                        },
                        {
                            "source": "#main/input_multiple_alignments",
                            "id": "#main/calculate_mirza/msa"
                        },
                        {
                            "source": "#main/input_mrna",
                            "id": "#main/calculate_mirza/seq"
                        },
                        {
                            "source": "#main/settings_mirza_threshold",
                            "id": "#main/calculate_mirza/threshold"
                        },
                        {
                            "source": "#main/input_tree",
                            "id": "#main/calculate_mirza/tree"
                        }
                    ],
                    "out": [
                        "#main/calculate_mirza/output"
                    ],
                    "id": "#main/calculate_mirza"
                },
                {
                    "run": "#concatenate.cwl",
                    "in": [
                        {
                            "source": "#main/merge_results_add_probability_and_calculate_per_gene_score/output",
                            "id": "#main/concatenate_results/files"
                        },
                        {
                            "source": "#main/output_file_name",
                            "id": "#main/concatenate_results/output_file"
                        }
                    ],
                    "out": [
                        "#main/concatenate_results/output"
                    ],
                    "id": "#main/concatenate_results"
                },
                {
                    "run": "#merge_results_add_probability_and_calculate_per_gene_score.cwl",
                    "scatter": [
                        "#main/merge_results_add_probability_and_calculate_per_gene_score/coords",
                        "#main/merge_results_add_probability_and_calculate_per_gene_score/mirza",
                        "#main/merge_results_add_probability_and_calculate_per_gene_score/contrafold",
                        "#main/merge_results_add_probability_and_calculate_per_gene_score/flanks",
                        "#main/merge_results_add_probability_and_calculate_per_gene_score/distance"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#main/settings_index_after_split",
                            "id": "#main/merge_results_add_probability_and_calculate_per_gene_score/column"
                        },
                        {
                            "source": "#main/calculate_contrafold/output",
                            "id": "#main/merge_results_add_probability_and_calculate_per_gene_score/contrafold"
                        },
                        {
                            "source": "#main/input_coords",
                            "id": "#main/merge_results_add_probability_and_calculate_per_gene_score/coords"
                        },
                        {
                            "source": "#main/calculate_distance/output",
                            "id": "#main/merge_results_add_probability_and_calculate_per_gene_score/distance"
                        },
                        {
                            "source": "#main/calculate_flanks/output",
                            "id": "#main/merge_results_add_probability_and_calculate_per_gene_score/flanks"
                        },
                        {
                            "source": "#main/calculate_mirza/output",
                            "id": "#main/merge_results_add_probability_and_calculate_per_gene_score/mirza"
                        },
                        {
                            "source": "#main/input_model_with_bls",
                            "id": "#main/merge_results_add_probability_and_calculate_per_gene_score/model_bls"
                        },
                        {
                            "source": "#main/input_model_without_bls",
                            "id": "#main/merge_results_add_probability_and_calculate_per_gene_score/model_nobls"
                        },
                        {
                            "source": "#main/settings_split_by",
                            "id": "#main/merge_results_add_probability_and_calculate_per_gene_score/split_by"
                        }
                    ],
                    "out": [
                        "#main/merge_results_add_probability_and_calculate_per_gene_score/output"
                    ],
                    "id": "#main/merge_results_add_probability_and_calculate_per_gene_score"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/concatenate_results/output",
                    "id": "#main/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "rg_calculate_MIRZA.py",
            "doc": "\nCalculate MIRZA interaction energy and MIRZA-based Branch Length Score\n(conservation) for the provided coordinates of putative targets.\n",
            "arguments": [
                "-o",
                "$(inputs.coords.basename).mirza"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 50,
                    "doc": "Length of the context sequence serounding binding site",
                    "inputBinding": {
                        "prefix": "--contextLen"
                    },
                    "id": "#calculate_MIRZA.cwl/contextLen"
                },
                {
                    "type": "File",
                    "doc": "File with target sites positions, miRNA and target gene ID",
                    "inputBinding": {
                        "prefix": "--coords"
                    },
                    "id": "#calculate_MIRZA.cwl/coords"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "MIRZA",
                    "doc": "Path to the MIRZA binary",
                    "inputBinding": {
                        "prefix": "--mirzabin"
                    },
                    "id": "#calculate_MIRZA.cwl/mirzabin"
                },
                {
                    "type": "File",
                    "doc": "Fasta file with miRNA sequences",
                    "inputBinding": {
                        "prefix": "--motifs"
                    },
                    "id": "#calculate_MIRZA.cwl/motifs"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "default": null,
                    "doc": "Archive (tar.gz) with multiple sequence alignment files",
                    "inputBinding": {
                        "prefix": "--msa"
                    },
                    "id": "#calculate_MIRZA.cwl/msa"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#calculate_MIRZA.cwl/onlymirza/yes",
                                "#calculate_MIRZA.cwl/onlymirza/no"
                            ]
                        }
                    ],
                    "default": "no",
                    "doc": "Calculate only MIRZA score for given coordinates",
                    "inputBinding": {
                        "prefix": "--onlyMIRZA"
                    },
                    "id": "#calculate_MIRZA.cwl/onlymirza"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "hg19",
                    "doc": "Reference organism to which alignments are performed (default=hg19)",
                    "inputBinding": {
                        "prefix": "--reforg"
                    },
                    "id": "#calculate_MIRZA.cwl/reforg"
                },
                {
                    "type": "File",
                    "doc": "Fasta with mRNA sequences",
                    "inputBinding": {
                        "prefix": "--seq"
                    },
                    "id": "#calculate_MIRZA.cwl/seq"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 20.0,
                    "doc": "Threshold for MIRZA score",
                    "inputBinding": {
                        "prefix": "--threshold"
                    },
                    "id": "#calculate_MIRZA.cwl/threshold"
                },
                {
                    "type": "File",
                    "doc": "Phylogenetic tree of the species used in alignment file",
                    "inputBinding": {
                        "prefix": "--tree"
                    },
                    "id": "#calculate_MIRZA.cwl/tree"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Be loud!",
                    "inputBinding": {
                        "prefix": "--verbose"
                    },
                    "id": "#calculate_MIRZA.cwl/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.coords.basename).mirza"
                    },
                    "id": "#calculate_MIRZA.cwl/output"
                }
            ],
            "id": "#calculate_MIRZA.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "rg_calculate_contrafold.py",
            "doc": "\nThe `CONTRAfold <http://contra.stanford.edu/contrafold/>`_ algorithm is used\nto calculate accessibility of target site for miRNA.\n",
            "arguments": [
                "--out",
                "$(inputs.coords.basename).contrafold"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 50,
                    "doc": "length of the context of the seed to be checked",
                    "inputBinding": {
                        "prefix": "--context"
                    },
                    "id": "#calculate_contrafold.cwl/context"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "doc": "length of the context sequence downstream binding site to be unwinded",
                    "inputBinding": {
                        "prefix": "--contextLen_L"
                    },
                    "id": "#calculate_contrafold.cwl/contextLen_L"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "doc": "length of the context sequence upstream binding site to be unwinded",
                    "inputBinding": {
                        "prefix": "--contextLen_U"
                    },
                    "id": "#calculate_contrafold.cwl/contextLen_U"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "contrafold",
                    "doc": "Path to CONTRAfold binary",
                    "inputBinding": {
                        "prefix": "--contrabin"
                    },
                    "id": "#calculate_contrafold.cwl/contrabin"
                },
                {
                    "type": "File",
                    "doc": "file with target sites positions, miRNA and target gene ID",
                    "inputBinding": {
                        "prefix": "--coords"
                    },
                    "id": "#calculate_contrafold.cwl/coords"
                },
                {
                    "type": "File",
                    "doc": "Fasta file with mRNA sequences",
                    "inputBinding": {
                        "prefix": "--seq"
                    },
                    "id": "#calculate_contrafold.cwl/seq"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Be loud!",
                    "inputBinding": {
                        "prefix": "--verbose"
                    },
                    "id": "#calculate_contrafold.cwl/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.coords.basename).contrafold"
                    },
                    "id": "#calculate_contrafold.cwl/output"
                }
            ],
            "id": "#calculate_contrafold.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "rg_calculate_distance.py",
            "doc": "\nCalculate distance to the boundary based on provided\ncoordinates for targets.\n",
            "arguments": [
                "-o",
                "$(inputs.coords.basename).distance"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 50,
                    "doc": "length of the context sequence serounding binding site",
                    "inputBinding": {
                        "prefix": "--contextLen"
                    },
                    "id": "#calculate_distance.cwl/contextLen"
                },
                {
                    "type": "File",
                    "doc": "file with target sites positions, miRNA and target gene ID",
                    "inputBinding": {
                        "prefix": "--coords"
                    },
                    "id": "#calculate_distance.cwl/coords"
                },
                {
                    "type": "File",
                    "doc": "fasta with mRNA sequences",
                    "inputBinding": {
                        "prefix": "--seq"
                    },
                    "id": "#calculate_distance.cwl/seq"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Be loud!",
                    "inputBinding": {
                        "prefix": "--verbose"
                    },
                    "id": "#calculate_distance.cwl/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.coords.basename).distance"
                    },
                    "id": "#calculate_distance.cwl/output"
                }
            ],
            "id": "#calculate_distance.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "rg_calculate_flanks_composition.py",
            "doc": "\nCalculate flanks composition using provided coordinates.\n",
            "arguments": [
                "--out",
                "$(inputs.coords.basename).flanks"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 50,
                    "doc": "length of the context sequence serounding binding site",
                    "inputBinding": {
                        "prefix": "--contextLen"
                    },
                    "id": "#calculate_flanks_composition.cwl/contextLen"
                },
                {
                    "type": "File",
                    "doc": "file with target sites positions, miRNA and target gene ID",
                    "inputBinding": {
                        "prefix": "--coords"
                    },
                    "id": "#calculate_flanks_composition.cwl/coords"
                },
                {
                    "type": "File",
                    "doc": "fasta with mRNA sequences",
                    "inputBinding": {
                        "prefix": "--seq"
                    },
                    "id": "#calculate_flanks_composition.cwl/seq"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Be loud!",
                    "inputBinding": {
                        "prefix": "--verbose"
                    },
                    "id": "#calculate_flanks_composition.cwl/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.coords.basename).flanks"
                    },
                    "id": "#calculate_flanks_composition.cwl/output"
                }
            ],
            "id": "#calculate_flanks_composition.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "cat",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#concatenate.cwl/files"
                },
                {
                    "type": "string",
                    "default": "concatenated_files",
                    "id": "#concatenate.cwl/output_file"
                }
            ],
            "stdout": "$(inputs.output_file)",
            "outputs": [
                {
                    "type": "File",
                    "id": "#concatenate.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    }
                }
            ],
            "id": "#concatenate.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "rg_merge_results_add_probability_and_calculate_per_gene_score.py",
            "doc": "\nMerge all results into one features table\n",
            "arguments": [
                "--output",
                "$(inputs.coords.basename).score"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "doc": "0 based column number to take after splitting, defaults to 0",
                    "inputBinding": {
                        "prefix": "--column"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/column"
                },
                {
                    "type": "File",
                    "doc": "CONTRAfold output file",
                    "inputBinding": {
                        "prefix": "--contrafold"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/contrafold"
                },
                {
                    "type": "File",
                    "doc": "File with target sites positions, miRNA and target gene ID",
                    "inputBinding": {
                        "prefix": "--coords"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/coords"
                },
                {
                    "type": "File",
                    "doc": "Distane to boundary output file",
                    "inputBinding": {
                        "prefix": "--distance"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/distance"
                },
                {
                    "type": "File",
                    "doc": "Flanks compositon output file",
                    "inputBinding": {
                        "prefix": "--flanks"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/flanks"
                },
                {
                    "type": "File",
                    "doc": "MIRZA output file",
                    "inputBinding": {
                        "prefix": "--mirza"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/mirza"
                },
                {
                    "type": "File",
                    "doc": "Path to model with branch length score",
                    "inputBinding": {
                        "prefix": "--model-bls"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/model_bls"
                },
                {
                    "type": "File",
                    "doc": "Path to model without branch length score",
                    "inputBinding": {
                        "prefix": "--model-nobls"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/model_nobls"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "GeneID",
                    "doc": "Name of the id eg. gene, transcript etc , defaults to GeneID",
                    "inputBinding": {
                        "prefix": "--name"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#merge_results_add_probability_and_calculate_per_gene_score.cwl/only_mirza/yes",
                                "#merge_results_add_probability_and_calculate_per_gene_score.cwl/only_mirza/no"
                            ]
                        }
                    ],
                    "default": "no",
                    "doc": "Calculate only MIRZA and DON'T calculate MIRZA BLS",
                    "inputBinding": {
                        "prefix": "--only-mirza"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/only_mirza"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "NONE",
                    "doc": "If the header of fasta has multiple annotations eg. transcript_id|entrez_id|wikiname split it and take only one, defaults to NONE",
                    "inputBinding": {
                        "prefix": "--split-by"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/split_by"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.12,
                    "doc": "Threshold for summing, defaults to 0.12",
                    "inputBinding": {
                        "prefix": "--threshold"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/threshold"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Be loud!",
                    "inputBinding": {
                        "prefix": "--verbose"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.coords.basename).score"
                    },
                    "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl/output"
                }
            ],
            "id": "#merge_results_add_probability_and_calculate_per_gene_score.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
